/**
* Jawbreaker - die Kopie
* Nach meinem Handy...
* Punkte berechnen sich wie folgt: Anzahl kugeln * (Anzahl Kugel -1)
* @author Friedemann Altrock
* @version 0.1 03/27/2007        (begin 03/23 5 h)
*/
/**
* Konzept:
* Ein Array aus Spielstein-Objekten, das nach und nach geleert wird.
*/

/**
* Spielfeld - Array aus SPALTEN
* @param size Objekt mit den feldern h und w
*/
function JawbreakerGame(size,n){
    //PUBLIC:
    /**
    * Funktion die der Stein aufruft wenn er angeklickt wird
    */
    this.select = function(s){
    	if(isNotSelected(s)){resetSelection();stoneScoreDiv.style.visibility = "hidden";}
    	_select(s);
    }
    this.getScore = function(){return getScores();}
    this.getSize = function(){return Size()};
    // debug helper
	this.debugPrintData = function(){alert(dbD());}
	this.debugPrintSelection = function(){alert(dbPS());}

    //PRIVATE:
  	// Getter
    function getScores(){return score;}
    function Size(){return size;};  // size ist private

    // fields
    /**
	* Enum SteinTyp - beschreibt die Farbe
	*/
	var type = new Array("yellow","lime","red","blue","violet","aqua","white");
    var score  = 0;
    var scoreNode = $t("0");
    var scoreDiv = $e("div");
    var showed = false;
    var data = new Array(size.w);
    var selection = new Array(size.w+2);// letztes feld ist die anzahl der steine die selektiert sind
    var node = $e("div");
	var stoneScoreDiv = $e("div");
    var bEnd = false;

    /// /// // debug helper functions
    function dbPS(){
        var str = "";
    	for(var i=0;i<size.w;i++){
        	str += selection[i].join(" ") +"\n";
        }
        return str + selection[size.w];
    }
    function dbD(){
        var str = "";
    	for(var i=0;i<size.w;i++){
        	for(var j=0;j<size.h;j++){
            	str += data[i][j]._color +" ";
            }
        	str += "\n";
        }
        return str
    }
	/// /// //


    // private helper functions
    /**
	* Funktion zum Auswrfeln der Farbe
	*/
	function randColor(){
		var r = Math.floor(Math.random() * 6);
		return type[r];
	}

	/**
	* Spielstein-Erzeuger
	* @param color Die Farbe (Typ) des Steins
	* @param pos Die Position des Steins im Feld
	*/
	function Stone (color,pos,f) {
	    var element = $e('img');
	    element.setAttribute('src',color+'.bmp');
	    element.style.border = "1px solid white";
	    element.style.position = "absolute";
	    element.style.left = pos.x*12;
	    element.style.top = pos.y*12;
        element.style.zIndex = 500;
	    if(color != "white")element.onclick = function(){this._field.select(this);}
		if(color != "white")element.ondblclick = function(){this._field.select(this);}
        element['_x'] = pos.x;
	    element['_y'] = pos.y;
	    element['_color'] = color;
	    element['_field'] = f;
	    return element;
	}

    /**
    * setzt alle felder der selektion zurck, entfernt rahmen
    */
    function resetSelection(){
    	for(var i=0;i<size.w;i++){
        	for(var j=0;j<size.h;j++){
            	if(selection[i][j]){
                	data[i][j].style.border = "1px solid white";
                    data[i][j].style.zIndex = 500;
                }

            	selection[i][j] = false;
            }
        }
        selection[size.w]=0;// anzahl steine
        selection[size.w+1]="white";
    }
    /**
    * helper beim anklicken:
    * wenn nicht angeklickt, dann wird neu selektiert sonst rausgenommen + punkte gemacht
    */
    function isNotSelected(s){return !(selection[s._x][s._y]);}

    /**
	* Funtion zum selektieren - Spiellogik
    * @param stone der Stein auf den geklickt wurde
	*/
	function _select(stone){
        if(selection[stone._x][stone._y]){
    		action();
    	}else{ // alle zusammenhngenden steine auswhlen -- dh rahmen drum setzen
			selection[stone._x][stone._y] = true;
	        selection[size.w]+=1;
            selection[size.w+1]=stone._color;

	 		if(stone._y == 0 || !selection[stone._x][stone._y-1]){
	       		stone.style.borderTop = "1px solid black";
	    	}else{
	        	data[stone._x][stone._y-1].style.borderBottom = "1px solid white";
	        }
	    	if(stone._y == (size.h-1) || !selection[stone._x][stone._y+1]){
    			stone.style.borderBottom = "1px solid black";
    		}else{
        		data[stone._x][stone._y+1].style.borderTop = "1px solid white";
	        }
    	    if(stone._x == 0 || !selection[stone._x-1][stone._y]){
        		stone.style.borderLeft = "1px solid black";
        	}else{
        		data[stone._x-1][stone._y].style.borderRight = "1px solid white";
       		}
        	if(stone._x == (size.w-1) || !selection[stone._x+1][stone._y]){
        		stone.style.borderRight = "1px solid black";
        	}else{
        		data[stone._x+1][stone._y].style.borderLeft = "1px solid white";
        	}
            stone.style.zIndex = 501;

        	/// /// /// // /// oben unten links rechts ???
    if(stone._y != 0 && !selection[stone._x][stone._y-1] && data[stone._x][stone._y-1]._color == stone._color)
        		_select(data[stone._x][stone._y-1]);

    if(stone._y != (size.h-1) && !selection[stone._x][stone._y+1] && data[stone._x][stone._y+1]._color == stone._color)
        		_select(data[stone._x][stone._y+1]);

	if(stone._x != 0 && !selection[stone._x-1][stone._y] && data[stone._x-1][stone._y]._color == stone._color)
        		_select(data[stone._x-1][stone._y]);

    if(stone._x != (size.w-1) && !selection[stone._x+1][stone._y] && data[stone._x+1][stone._y]._color == stone._color)
        		_select(data[stone._x+1][stone._y]);

            if(selection[size.w]==1){
            	resetSelection();
            }else{
            	var p = selection[size.w];p*=(p-1);
            	if(p != 0){
                	stoneScoreDiv.firstChild.nodeValue = p;
                	stoneScoreDiv.style.left = stone._x*12 -20 +"px";
             		stoneScoreDiv.style.top = stone._y*12 -15 +"px";
                    if(p>100)stoneScoreDiv.style.width = "25px";
                    else if(p<10) stoneScoreDiv.style.width = "10px";
                    else stoneScoreDiv.style.width = "20px";
                    stoneScoreDiv.style.visibility = "visible";
                    stoneScoreDiv.style.backgroundColor = stone._color;
            	}
            }
    	} //else selected
	} // function _select

    /**
    * Hier werden erst die kugeln nach unten bewegt und wenn dann eine zeile weg ist wird nachgeschoben
    */
    function action(){
        stoneScoreDiv.style.visibility = "hidden";
        if(selection[size.w+1] <= 1)return resetSelection(); // BUG doppelklick
        score += selection[size.w]*(selection[size.w]-1);

        // von links nach rechts spalten durchgehen und schauen ob etwas rausgenommen werden muss
        // dann alles darber runter ziehen und den rest auffllen
        for(var i=0;i<size.w;i++){
        	// von oben nach unten durchgehen
            for(var j=0;j<size.h;j++){
            	if(selection[i][j]){ // j kugeln sind ber der selektierten, alle um eins runter
                	for(var jj=0;jj<j;jj++){
                    // die kugeln von unten nach oben, die letzte wird ersetzt (jj=j)
                    	data[i][j-jj] = data[i][j-jj-1];
                        data[i][j-jj]._y += 1;
                        data[i][j-jj].style.top = data[i][j-jj]._y*12 +"px";
                    }
                    data[i][0] = Stone("white",{x:i,y:0},this);//oberste ist weg
                }

            }
        }
        // leere spalte? weg damit!
        for(var i=0;i<size.w;i++){
        	if(data[i][size.h-1]._color == "white"){//unterste kugel weg??
            	//alert("spalte weg!");
            	// alle links davon nach rechts schieben.
				// i spalten sind noch links.
                for(var ii=0;ii<i;ii++){
                	data[i-ii] = data[i-ii-1];
                    // alle steine nach rechts bewegen
                    for(var j=0;j<size.h;j++){
                    	data[i-ii][j]._x += 1;
                        data[i-ii][j].style.left = data[i-ii][j]._x*12 +"px";
                    }
                }
                data[0] = new Array(size.h);//leere spalte ganz links einfgen
                for(var j=0;j<size.h;j++){
                	data[0][j] = Stone("white",{x:0,y:j},this);
                }
            }
        }
        bEnd = true;
        // schauen ob spiel vorbei- dafr von unten rechts nach min einer 2er kombi suchen.
        for(var i=size.w-1;i>=0;--i){
        	for(var j=size.h-1;j>=0;--j){
            	if(data[i][j]._color == "white")break; // nchste spalte;
                // unten oben rechts links
                if(j < (size.h-1) && data[i][j+1]._color == data[i][j]._color)
                	bEnd = false;
                if(j > 0 && data[i][j-1]._color == data[i][j]._color)
                	bEnd = false;
                if(i < (size.w-1) && data[i+1][j]._color == data[i][j]._color)
                	bEnd = false;
                if(i > 0 && data[i-1][j]._color == data[i][j]._color)
                	bEnd = false;
            }
            if(!bEnd)
            	break;
        }
        resetSelection();
        show(); // darstellung akualisieren
    }

	/**
    * Funktion die alles in den DOM-baum hngt
    */
    function show(){
    	if(!showed){
            n.appendChild(node);
           	for(var i=0;i<size.w;i++){
				for(var j=0;j<size.h;j++){
            		node.appendChild(data[i][j]);
            	}
        	}
            if(navigator.userAgent.search(/MSIE/)!= -1){
            	node.style.height = size.h*12+4;
            	node.style.width = size.w*12+4;
            }else{
            	node.style.height = size.h*12+2;
            	node.style.width = size.w*12+2;
            }
            node.appendChild(scoreDiv);
    		node.appendChild(stoneScoreDiv);
            showed = true;
        }else
        {//update
        	var e = null;
            var h = size.h;
            for(var i=0;i<size.w;i++){
				for(var j=0;j<h;j++){
            		e = node.childNodes[i*h + j];
                     //wenn nicht gleiches element -> daten wurden gendert
                    //if(e.style.top != this.data[i][j].left || e.style.left != this.data[i][j].style.left){
                    if(e != data[i][j])
                    	node.replaceChild(data[i][j],e);
            	}
        	}

        	scoreNode.nodeValue = score;
            if(bEnd){
            	scoreDiv.style.color = "red";
                scoreDiv.style.fontWeight = "bold";
            }
        }
    }


    // Constructor code
    node.style.border = "1px solid black";
    node.style.position = "absolute";
    node.style.top = "0px";
    node.style.left = "0px";

    scoreDiv.appendChild(scoreNode);
    scoreDiv.style.position = "absolute";
	scoreDiv.style.top = node.style.top;
    scoreDiv.style.left = (size.w*12) + 8 +"px";
    scoreDiv.style.border = "1px solid black";
    scoreDiv.style.backgroundColor = "lightgrey";
    scoreDiv.style.height = "17px";
    scoreDiv.style.width = "30px";
    scoreDiv.style.fontSize = "13px";

    stoneScoreDiv.style.position = "absolute";
    stoneScoreDiv.style.backgroundColor = "lightgrey";
    stoneScoreDiv.style.border = "1px solid black";
    stoneScoreDiv.style.fontSize = "13px";
    stoneScoreDiv.style.height = "16px";
    stoneScoreDiv.style.width = "20px";
    stoneScoreDiv.appendChild($t("0"));
    stoneScoreDiv.style.zIndex = 502;
    stoneScoreDiv.style.visibility = "hidden";

    for(var i=0;i<size.w;i++){
    	data[i] = new Array(size.h);
        for(var j=0;j<size.h;j++){
        	data[i][j] = Stone(randColor(),{x:i,y:j},this);
        }
    }

    for(var i=0;i<size.w;i++){
    	selection[i] = new Array(size.h);
    }
    resetSelection();

    show(); // show up
    /////////
}// class JawbreakerGame